/* display.c generated by valac 0.39.5, the Vala compiler
 * generated from display.vala, do not modify */

/* This file is part of GNOME Boxes. License: LGPLv2+*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <libcommon.h>
#include <stdlib.h>
#include <string.h>


#define BOXES_TYPE_IPROPERTIES_PROVIDER (boxes_iproperties_provider_get_type ())
#define BOXES_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProvider))
#define BOXES_IS_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER))
#define BOXES_IPROPERTIES_PROVIDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProviderIface))

typedef struct _BoxesIPropertiesProvider BoxesIPropertiesProvider;
typedef struct _BoxesIPropertiesProviderIface BoxesIPropertiesProviderIface;

#define BOXES_TYPE_PROPERTIES_PAGE (boxes_properties_page_get_type ())

#define BOXES_TYPE_PROPERTY (boxes_property_get_type ())
#define BOXES_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_PROPERTY, BoxesProperty))
#define BOXES_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_PROPERTY, BoxesPropertyClass))
#define BOXES_IS_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_PROPERTY))
#define BOXES_IS_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_PROPERTY))
#define BOXES_PROPERTY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_PROPERTY, BoxesPropertyClass))

typedef struct _BoxesProperty BoxesProperty;
typedef struct _BoxesPropertyClass BoxesPropertyClass;

#define BOXES_TYPE_DISPLAY (boxes_display_get_type ())
#define BOXES_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_DISPLAY, BoxesDisplay))
#define BOXES_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_DISPLAY, BoxesDisplayClass))
#define BOXES_IS_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_DISPLAY))
#define BOXES_IS_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_DISPLAY))
#define BOXES_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_DISPLAY, BoxesDisplayClass))

typedef struct _BoxesDisplay BoxesDisplay;
typedef struct _BoxesDisplayClass BoxesDisplayClass;
typedef struct _BoxesDisplayPrivate BoxesDisplayPrivate;
enum  {
	BOXES_DISPLAY_0_PROPERTY,
	BOXES_DISPLAY_PROTOCOL_PROPERTY,
	BOXES_DISPLAY_URI_PROPERTY,
	BOXES_DISPLAY_CONFIG_PROPERTY,
	BOXES_DISPLAY_CAN_GRAB_MOUSE_PROPERTY,
	BOXES_DISPLAY_MOUSE_GRABBED_PROPERTY,
	BOXES_DISPLAY_KEYBOARD_GRABBED_PROPERTY,
	BOXES_DISPLAY_NEED_PASSWORD_PROPERTY,
	BOXES_DISPLAY_NEED_USERNAME_PROPERTY,
	BOXES_DISPLAY_PASSWORD_PROPERTY,
	BOXES_DISPLAY_USERNAME_PROPERTY,
	BOXES_DISPLAY_NUM_PROPERTIES
};
static GParamSpec* boxes_display_properties[BOXES_DISPLAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
enum  {
	BOXES_DISPLAY_SHOW_SIGNAL,
	BOXES_DISPLAY_HIDE_SIGNAL,
	BOXES_DISPLAY_DISCONNECTED_SIGNAL,
	BOXES_DISPLAY_GOT_ERROR_SIGNAL,
	BOXES_DISPLAY_NUM_SIGNALS
};
static guint boxes_display_signals[BOXES_DISPLAY_NUM_SIGNALS] = {0};

typedef enum  {
	BOXES_PROPERTIES_PAGE_GENERAL,
	BOXES_PROPERTIES_PAGE_SYSTEM,
	BOXES_PROPERTIES_PAGE_DEVICES,
	BOXES_PROPERTIES_PAGE_SNAPSHOTS,
	BOXES_PROPERTIES_PAGE_LAST
} BoxesPropertiesPage;

struct _BoxesIPropertiesProviderIface {
	GTypeInterface parent_iface;
	GList* (*get_properties) (BoxesIPropertiesProvider* self, BoxesPropertiesPage page);
};

typedef gint (*BoxesDisplayOpenFDFunc) (void* user_data);
struct _BoxesDisplay {
	GObject parent_instance;
	BoxesDisplayPrivate * priv;
	gboolean connected;
	GHashTable* displays;
};

struct _BoxesDisplayClass {
	GObjectClass parent_class;
	GtkWidget* (*get_display) (BoxesDisplay* self, gint n);
	GdkPixbuf* (*get_pixbuf) (BoxesDisplay* self, gint n, GError** error);
	void (*set_enable_audio) (BoxesDisplay* self, gboolean enable);
	gboolean (*should_keep_alive) (BoxesDisplay* self);
	void (*connect_it) (BoxesDisplay* self, BoxesDisplayOpenFDFunc open_fd, void* open_fd_target, GDestroyNotify open_fd_target_destroy_notify, GError** error);
	void (*disconnect_it) (BoxesDisplay* self);
	void (*collect_logs) (BoxesDisplay* self, GString* builder);
	void (*send_keys) (BoxesDisplay* self, guint* keyvals, int keyvals_length1);
	GList* (*get_properties) (BoxesDisplay* self, BoxesPropertiesPage page);
	const gchar* (*get_protocol) (BoxesDisplay* self);
	gchar* (*get_uri) (BoxesDisplay* self);
};

struct _BoxesDisplayPrivate {
	BoxesBoxConfig* _config;
	gboolean _can_grab_mouse;
	gboolean _mouse_grabbed;
	gboolean _keyboard_grabbed;
	gboolean _need_password;
	gboolean _need_username;
	gchar* _password;
	gchar* _username;
	gint64 started_time;
};


static gpointer boxes_display_parent_class = NULL;
static BoxesIPropertiesProviderIface * boxes_display_boxes_iproperties_provider_parent_iface = NULL;

GType boxes_properties_page_get_type (void) G_GNUC_CONST;
GType boxes_property_get_type (void) G_GNUC_CONST;
GType boxes_iproperties_provider_get_type (void) G_GNUC_CONST;
GType boxes_display_get_type (void) G_GNUC_CONST;
#define BOXES_DISPLAY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BOXES_TYPE_DISPLAY, BoxesDisplayPrivate))
void boxes_display_access_finish (BoxesDisplay* self);
GtkWidget* boxes_display_get_display (BoxesDisplay* self,
                                      gint n);
static GtkWidget* boxes_display_real_get_display (BoxesDisplay* self,
                                           gint n);
GdkPixbuf* boxes_display_get_pixbuf (BoxesDisplay* self,
                                     gint n,
                                     GError** error);
static GdkPixbuf* boxes_display_real_get_pixbuf (BoxesDisplay* self,
                                          gint n,
                                          GError** error);
void boxes_display_set_enable_audio (BoxesDisplay* self,
                                     gboolean enable);
static void boxes_display_real_set_enable_audio (BoxesDisplay* self,
                                          gboolean enable);
gboolean boxes_display_should_keep_alive (BoxesDisplay* self);
static gboolean boxes_display_real_should_keep_alive (BoxesDisplay* self);
void boxes_display_connect_it (BoxesDisplay* self,
                               BoxesDisplayOpenFDFunc open_fd,
                               void* open_fd_target,
                               GDestroyNotify open_fd_target_destroy_notify,
                               GError** error);
static void boxes_display_real_connect_it (BoxesDisplay* self,
                                    BoxesDisplayOpenFDFunc open_fd,
                                    void* open_fd_target,
                                    GDestroyNotify open_fd_target_destroy_notify,
                                    GError** error);
void boxes_display_disconnect_it (BoxesDisplay* self);
static void boxes_display_real_disconnect_it (BoxesDisplay* self);
void boxes_display_collect_logs (BoxesDisplay* self,
                                 GString* builder);
static void boxes_display_real_collect_logs (BoxesDisplay* self,
                                      GString* builder);
void boxes_display_send_keys (BoxesDisplay* self,
                              guint* keyvals,
                              int keyvals_length1);
static void boxes_display_real_send_keys (BoxesDisplay* self,
                                   guint* keyvals,
                                   int keyvals_length1);
GList* boxes_display_get_properties (BoxesDisplay* self,
                                     BoxesPropertiesPage page);
static GList* boxes_display_real_get_properties (BoxesDisplay* self,
                                          BoxesPropertiesPage page);
void boxes_display_access_start (BoxesDisplay* self);
BoxesBoxConfig* boxes_display_get_config (BoxesDisplay* self);
BoxesDisplay* boxes_display_construct (GType object_type);
const gchar* boxes_display_get_protocol (BoxesDisplay* self);
gchar* boxes_display_get_uri (BoxesDisplay* self);
void boxes_display_set_config (BoxesDisplay* self,
                               BoxesBoxConfig* value);
gboolean boxes_display_get_can_grab_mouse (BoxesDisplay* self);
void boxes_display_set_can_grab_mouse (BoxesDisplay* self,
                                       gboolean value);
gboolean boxes_display_get_mouse_grabbed (BoxesDisplay* self);
void boxes_display_set_mouse_grabbed (BoxesDisplay* self,
                                      gboolean value);
gboolean boxes_display_get_keyboard_grabbed (BoxesDisplay* self);
void boxes_display_set_keyboard_grabbed (BoxesDisplay* self,
                                         gboolean value);
gboolean boxes_display_get_need_password (BoxesDisplay* self);
void boxes_display_set_need_password (BoxesDisplay* self,
                                      gboolean value);
gboolean boxes_display_get_need_username (BoxesDisplay* self);
void boxes_display_set_need_username (BoxesDisplay* self,
                                      gboolean value);
const gchar* boxes_display_get_password (BoxesDisplay* self);
void boxes_display_set_password (BoxesDisplay* self,
                                 const gchar* value);
const gchar* boxes_display_get_username (BoxesDisplay* self);
void boxes_display_set_username (BoxesDisplay* self,
                                 const gchar* value);
static GObject * boxes_display_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void _g_object_unref0_ (gpointer var);
static void boxes_display_finalize (GObject * obj);
static void _vala_boxes_display_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_boxes_display_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);


static GtkWidget*
boxes_display_real_get_display (BoxesDisplay* self,
                                gint n)
{
#line 25 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_get_display'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 25 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return NULL;
#line 224 "display.c"
}


GtkWidget*
boxes_display_get_display (BoxesDisplay* self,
                           gint n)
{
#line 25 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->get_display (self, n);
#line 236 "display.c"
}


static GdkPixbuf*
boxes_display_real_get_pixbuf (BoxesDisplay* self,
                               gint n,
                               GError** error)
{
#line 26 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_get_pixbuf'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 26 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return NULL;
#line 249 "display.c"
}


GdkPixbuf*
boxes_display_get_pixbuf (BoxesDisplay* self,
                          gint n,
                          GError** error)
{
#line 26 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->get_pixbuf (self, n, error);
#line 262 "display.c"
}


static void
boxes_display_real_set_enable_audio (BoxesDisplay* self,
                                     gboolean enable)
{
#line 27 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_set_enable_audio'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 27 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return;
#line 274 "display.c"
}


void
boxes_display_set_enable_audio (BoxesDisplay* self,
                                gboolean enable)
{
#line 27 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 27 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	BOXES_DISPLAY_GET_CLASS (self)->set_enable_audio (self, enable);
#line 286 "display.c"
}


static gboolean
boxes_display_real_should_keep_alive (BoxesDisplay* self)
{
	gboolean result = FALSE;
#line 30 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	result = FALSE;
#line 30 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return result;
#line 298 "display.c"
}


gboolean
boxes_display_should_keep_alive (BoxesDisplay* self)
{
#line 29 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->should_keep_alive (self);
#line 309 "display.c"
}


static void
boxes_display_real_connect_it (BoxesDisplay* self,
                               BoxesDisplayOpenFDFunc open_fd,
                               void* open_fd_target,
                               GDestroyNotify open_fd_target_destroy_notify,
                               GError** error)
{
#line 33 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_connect_it'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 33 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return;
#line 324 "display.c"
}


void
boxes_display_connect_it (BoxesDisplay* self,
                          BoxesDisplayOpenFDFunc open_fd,
                          void* open_fd_target,
                          GDestroyNotify open_fd_target_destroy_notify,
                          GError** error)
{
#line 33 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 33 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	BOXES_DISPLAY_GET_CLASS (self)->connect_it (self, open_fd, open_fd_target, open_fd_target_destroy_notify, error);
#line 339 "display.c"
}


static void
boxes_display_real_disconnect_it (BoxesDisplay* self)
{
#line 34 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_disconnect_it'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 34 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return;
#line 350 "display.c"
}


void
boxes_display_disconnect_it (BoxesDisplay* self)
{
#line 34 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 34 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	BOXES_DISPLAY_GET_CLASS (self)->disconnect_it (self);
#line 361 "display.c"
}


static void
boxes_display_real_collect_logs (BoxesDisplay* self,
                                 GString* builder)
{
#line 36 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (builder != NULL);
#line 371 "display.c"
}


void
boxes_display_collect_logs (BoxesDisplay* self,
                            GString* builder)
{
#line 36 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 36 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	BOXES_DISPLAY_GET_CLASS (self)->collect_logs (self, builder);
#line 383 "display.c"
}


static void
boxes_display_real_send_keys (BoxesDisplay* self,
                              guint* keyvals,
                              int keyvals_length1)
{
#line 38 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_send_keys'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 38 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return;
#line 396 "display.c"
}


void
boxes_display_send_keys (BoxesDisplay* self,
                         guint* keyvals,
                         int keyvals_length1)
{
#line 38 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 38 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	BOXES_DISPLAY_GET_CLASS (self)->send_keys (self, keyvals, keyvals_length1);
#line 409 "display.c"
}


static GList*
boxes_display_real_get_properties (BoxesDisplay* self,
                                   BoxesPropertiesPage page)
{
#line 40 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_get_properties'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 40 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return NULL;
#line 421 "display.c"
}


GList*
boxes_display_get_properties (BoxesDisplay* self,
                              BoxesPropertiesPage page)
{
#line 40 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->get_properties (self, page);
#line 433 "display.c"
}


void
boxes_display_access_start (BoxesDisplay* self)
{
	gint64 _tmp0_;
	BoxesBoxConfig* _tmp1_;
	BoxesBoxConfig* _tmp2_;
	BoxesBoxConfig* _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	BoxesBoxConfig* _tmp6_;
	gint64 _tmp7_;
	gint64 _tmp8_;
#line 45 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 46 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp0_ = self->priv->started_time;
#line 46 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	if (_tmp0_ != ((gint64) 0)) {
#line 47 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		return;
#line 457 "display.c"
	}
#line 49 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	self->priv->started_time = g_get_monotonic_time ();
#line 50 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp1_ = self->priv->_config;
#line 50 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	boxes_box_config_set_access_last_time (_tmp1_, g_get_real_time ());
#line 51 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp2_ = self->priv->_config;
#line 51 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp3_ = self->priv->_config;
#line 51 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp4_ = boxes_box_config_get_access_ntimes (_tmp3_);
#line 51 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp5_ = _tmp4_;
#line 51 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	boxes_box_config_set_access_ntimes (_tmp3_, _tmp5_ + 1);
#line 53 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp6_ = self->priv->_config;
#line 53 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp7_ = boxes_box_config_get_access_first_time (_tmp6_);
#line 53 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp8_ = _tmp7_;
#line 53 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	if (_tmp8_ == ((gint64) 0)) {
#line 483 "display.c"
		BoxesBoxConfig* _tmp9_;
		BoxesBoxConfig* _tmp10_;
		gint64 _tmp11_;
		gint64 _tmp12_;
#line 54 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		_tmp9_ = self->priv->_config;
#line 54 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		_tmp10_ = self->priv->_config;
#line 54 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		_tmp11_ = boxes_box_config_get_access_last_time (_tmp10_);
#line 54 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		_tmp12_ = _tmp11_;
#line 54 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		boxes_box_config_set_access_first_time (_tmp9_, _tmp12_);
#line 498 "display.c"
	}
}


void
boxes_display_access_finish (BoxesDisplay* self)
{
	gint64 _tmp0_;
	gint64 duration = 0LL;
	gint64 _tmp1_;
	gint64 _tmp2_;
	BoxesBoxConfig* _tmp3_;
	BoxesBoxConfig* _tmp4_;
	gint64 _tmp5_;
	gint64 _tmp6_;
	gint64 _tmp7_;
#line 57 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 58 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp0_ = self->priv->started_time;
#line 58 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	if (_tmp0_ == ((gint64) 0)) {
#line 59 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		return;
#line 523 "display.c"
	}
#line 61 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp1_ = self->priv->started_time;
#line 61 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	duration = g_get_monotonic_time () - _tmp1_;
#line 62 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp2_ = duration;
#line 62 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	duration = _tmp2_ / 1000000;
#line 63 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp3_ = self->priv->_config;
#line 63 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp4_ = self->priv->_config;
#line 63 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp5_ = boxes_box_config_get_access_total_time (_tmp4_);
#line 63 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp6_ = _tmp5_;
#line 63 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp7_ = duration;
#line 63 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	boxes_box_config_set_access_total_time (_tmp4_, _tmp6_ + _tmp7_);
#line 65 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	self->priv->started_time = (gint64) 0;
#line 547 "display.c"
}


BoxesDisplay*
boxes_display_construct (GType object_type)
{
	BoxesDisplay * self = NULL;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	self = (BoxesDisplay*) g_object_new (object_type, NULL);
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return self;
#line 559 "display.c"
}


const gchar*
boxes_display_get_protocol (BoxesDisplay* self)
{
#line 5 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->get_protocol (self);
#line 570 "display.c"
}


gchar*
boxes_display_get_uri (BoxesDisplay* self)
{
#line 6 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 6 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->get_uri (self);
#line 581 "display.c"
}


BoxesBoxConfig*
boxes_display_get_config (BoxesDisplay* self)
{
	BoxesBoxConfig* result;
	BoxesBoxConfig* _tmp0_;
#line 8 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp0_ = self->priv->_config;
#line 8 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	result = _tmp0_;
#line 8 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return result;
#line 598 "display.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 8 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return self ? g_object_ref (self) : NULL;
#line 607 "display.c"
}


void
boxes_display_set_config (BoxesDisplay* self,
                          BoxesBoxConfig* value)
{
#line 8 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 8 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	if (boxes_display_get_config (self) != value) {
#line 619 "display.c"
		BoxesBoxConfig* _tmp0_;
#line 8 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 8 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		_g_object_unref0 (self->priv->_config);
#line 8 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		self->priv->_config = _tmp0_;
#line 8 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_CONFIG_PROPERTY]);
#line 629 "display.c"
	}
}


gboolean
boxes_display_get_can_grab_mouse (BoxesDisplay* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 9 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 9 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp0_ = self->priv->_can_grab_mouse;
#line 9 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	result = _tmp0_;
#line 9 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return result;
#line 647 "display.c"
}


void
boxes_display_set_can_grab_mouse (BoxesDisplay* self,
                                  gboolean value)
{
#line 9 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 9 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	if (boxes_display_get_can_grab_mouse (self) != value) {
#line 9 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		self->priv->_can_grab_mouse = value;
#line 9 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_CAN_GRAB_MOUSE_PROPERTY]);
#line 663 "display.c"
	}
}


gboolean
boxes_display_get_mouse_grabbed (BoxesDisplay* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 10 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 10 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp0_ = self->priv->_mouse_grabbed;
#line 10 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	result = _tmp0_;
#line 10 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return result;
#line 681 "display.c"
}


void
boxes_display_set_mouse_grabbed (BoxesDisplay* self,
                                 gboolean value)
{
#line 10 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 10 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	if (boxes_display_get_mouse_grabbed (self) != value) {
#line 10 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		self->priv->_mouse_grabbed = value;
#line 10 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_MOUSE_GRABBED_PROPERTY]);
#line 697 "display.c"
	}
}


gboolean
boxes_display_get_keyboard_grabbed (BoxesDisplay* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 11 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 11 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp0_ = self->priv->_keyboard_grabbed;
#line 11 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	result = _tmp0_;
#line 11 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return result;
#line 715 "display.c"
}


void
boxes_display_set_keyboard_grabbed (BoxesDisplay* self,
                                    gboolean value)
{
#line 11 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 11 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	if (boxes_display_get_keyboard_grabbed (self) != value) {
#line 11 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		self->priv->_keyboard_grabbed = value;
#line 11 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_KEYBOARD_GRABBED_PROPERTY]);
#line 731 "display.c"
	}
}


gboolean
boxes_display_get_need_password (BoxesDisplay* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 12 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 12 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp0_ = self->priv->_need_password;
#line 12 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	result = _tmp0_;
#line 12 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return result;
#line 749 "display.c"
}


void
boxes_display_set_need_password (BoxesDisplay* self,
                                 gboolean value)
{
#line 12 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 12 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	if (boxes_display_get_need_password (self) != value) {
#line 12 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		self->priv->_need_password = value;
#line 12 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_NEED_PASSWORD_PROPERTY]);
#line 765 "display.c"
	}
}


gboolean
boxes_display_get_need_username (BoxesDisplay* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 13 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 13 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp0_ = self->priv->_need_username;
#line 13 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	result = _tmp0_;
#line 13 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return result;
#line 783 "display.c"
}


void
boxes_display_set_need_username (BoxesDisplay* self,
                                 gboolean value)
{
#line 13 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 13 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	if (boxes_display_get_need_username (self) != value) {
#line 13 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		self->priv->_need_username = value;
#line 13 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_NEED_USERNAME_PROPERTY]);
#line 799 "display.c"
	}
}


const gchar*
boxes_display_get_password (BoxesDisplay* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 14 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 14 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp0_ = self->priv->_password;
#line 14 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	result = _tmp0_;
#line 14 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return result;
#line 817 "display.c"
}


void
boxes_display_set_password (BoxesDisplay* self,
                            const gchar* value)
{
#line 14 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 14 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	if (g_strcmp0 (value, boxes_display_get_password (self)) != 0) {
#line 829 "display.c"
		gchar* _tmp0_;
#line 14 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		_tmp0_ = g_strdup (value);
#line 14 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		_g_free0 (self->priv->_password);
#line 14 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		self->priv->_password = _tmp0_;
#line 14 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_PASSWORD_PROPERTY]);
#line 839 "display.c"
	}
}


const gchar*
boxes_display_get_username (BoxesDisplay* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 15 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 15 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp0_ = self->priv->_username;
#line 15 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	result = _tmp0_;
#line 15 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return result;
#line 857 "display.c"
}


void
boxes_display_set_username (BoxesDisplay* self,
                            const gchar* value)
{
#line 15 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_return_if_fail (self != NULL);
#line 15 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	if (g_strcmp0 (value, boxes_display_get_username (self)) != 0) {
#line 869 "display.c"
		gchar* _tmp0_;
#line 15 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		_tmp0_ = g_strdup (value);
#line 15 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		_g_free0 (self->priv->_username);
#line 15 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		self->priv->_username = _tmp0_;
#line 15 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_USERNAME_PROPERTY]);
#line 879 "display.c"
	}
}


static void
_g_object_unref0_ (gpointer var)
{
#line 73 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 889 "display.c"
}


static GObject *
boxes_display_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BoxesDisplay * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
#line 72 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	parent_class = G_OBJECT_CLASS (boxes_display_parent_class);
#line 72 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 72 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_DISPLAY, BoxesDisplay);
#line 73 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp0_ = g_direct_hash;
#line 73 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp1_ = g_direct_equal;
#line 73 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, _g_object_unref0_);
#line 73 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_g_hash_table_unref0 (self->displays);
#line 73 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	self->displays = _tmp2_;
#line 72 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	return obj;
#line 922 "display.c"
}


static void
boxes_display_class_init (BoxesDisplayClass * klass)
{
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	boxes_display_parent_class = g_type_class_peek_parent (klass);
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_type_class_add_private (klass, sizeof (BoxesDisplayPrivate));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	((BoxesDisplayClass *) klass)->get_display = (GtkWidget* (*) (BoxesDisplay *, gint)) boxes_display_real_get_display;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	((BoxesDisplayClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (BoxesDisplay *, gint, GError**)) boxes_display_real_get_pixbuf;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	((BoxesDisplayClass *) klass)->set_enable_audio = (void (*) (BoxesDisplay *, gboolean)) boxes_display_real_set_enable_audio;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	((BoxesDisplayClass *) klass)->should_keep_alive = (gboolean (*) (BoxesDisplay *)) boxes_display_real_should_keep_alive;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	((BoxesDisplayClass *) klass)->connect_it = (void (*) (BoxesDisplay *, BoxesDisplayOpenFDFunc, void*, GDestroyNotify, GError**)) boxes_display_real_connect_it;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	((BoxesDisplayClass *) klass)->disconnect_it = (void (*) (BoxesDisplay *)) boxes_display_real_disconnect_it;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	((BoxesDisplayClass *) klass)->collect_logs = (void (*) (BoxesDisplay *, GString*)) boxes_display_real_collect_logs;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	((BoxesDisplayClass *) klass)->send_keys = (void (*) (BoxesDisplay *, guint*, int)) boxes_display_real_send_keys;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	((BoxesDisplayClass *) klass)->get_properties = (GList* (*) (BoxesDisplay *, BoxesPropertiesPage)) boxes_display_real_get_properties;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_boxes_display_get_property;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_boxes_display_set_property;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	G_OBJECT_CLASS (klass)->constructor = boxes_display_constructor;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	G_OBJECT_CLASS (klass)->finalize = boxes_display_finalize;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_PROTOCOL_PROPERTY, boxes_display_properties[BOXES_DISPLAY_PROTOCOL_PROPERTY] = g_param_spec_string ("protocol", "protocol", "protocol", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_URI_PROPERTY, boxes_display_properties[BOXES_DISPLAY_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_CONFIG_PROPERTY, boxes_display_properties[BOXES_DISPLAY_CONFIG_PROPERTY] = g_param_spec_object ("config", "config", "config", BOXES_TYPE_BOX_CONFIG, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_CAN_GRAB_MOUSE_PROPERTY, boxes_display_properties[BOXES_DISPLAY_CAN_GRAB_MOUSE_PROPERTY] = g_param_spec_boolean ("can-grab-mouse", "can-grab-mouse", "can-grab-mouse", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_MOUSE_GRABBED_PROPERTY, boxes_display_properties[BOXES_DISPLAY_MOUSE_GRABBED_PROPERTY] = g_param_spec_boolean ("mouse-grabbed", "mouse-grabbed", "mouse-grabbed", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_KEYBOARD_GRABBED_PROPERTY, boxes_display_properties[BOXES_DISPLAY_KEYBOARD_GRABBED_PROPERTY] = g_param_spec_boolean ("keyboard-grabbed", "keyboard-grabbed", "keyboard-grabbed", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_NEED_PASSWORD_PROPERTY, boxes_display_properties[BOXES_DISPLAY_NEED_PASSWORD_PROPERTY] = g_param_spec_boolean ("need-password", "need-password", "need-password", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_NEED_USERNAME_PROPERTY, boxes_display_properties[BOXES_DISPLAY_NEED_USERNAME_PROPERTY] = g_param_spec_boolean ("need-username", "need-username", "need-username", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_PASSWORD_PROPERTY, boxes_display_properties[BOXES_DISPLAY_PASSWORD_PROPERTY] = g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_USERNAME_PROPERTY, boxes_display_properties[BOXES_DISPLAY_USERNAME_PROPERTY] = g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	boxes_display_signals[BOXES_DISPLAY_SHOW_SIGNAL] = g_signal_new ("show", BOXES_TYPE_DISPLAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	boxes_display_signals[BOXES_DISPLAY_HIDE_SIGNAL] = g_signal_new ("hide", BOXES_TYPE_DISPLAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	boxes_display_signals[BOXES_DISPLAY_DISCONNECTED_SIGNAL] = g_signal_new ("disconnected", BOXES_TYPE_DISPLAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	boxes_display_signals[BOXES_DISPLAY_GOT_ERROR_SIGNAL] = g_signal_new ("got-error", BOXES_TYPE_DISPLAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 987 "display.c"
}


static void
boxes_display_boxes_iproperties_provider_interface_init (BoxesIPropertiesProviderIface * iface)
{
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	boxes_display_boxes_iproperties_provider_parent_iface = g_type_interface_peek_parent (iface);
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	iface->get_properties = (GList* (*) (BoxesIPropertiesProvider *, BoxesPropertiesPage)) boxes_display_get_properties;
#line 998 "display.c"
}


static void
boxes_display_instance_init (BoxesDisplay * self)
{
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	self->priv = BOXES_DISPLAY_GET_PRIVATE (self);
#line 1007 "display.c"
}


static void
boxes_display_finalize (GObject * obj)
{
	BoxesDisplay * self;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_DISPLAY, BoxesDisplay);
#line 69 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	boxes_display_access_finish (self);
#line 8 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_g_object_unref0 (self->priv->_config);
#line 14 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_g_free0 (self->priv->_password);
#line 15 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_g_free0 (self->priv->_username);
#line 42 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	_g_hash_table_unref0 (self->displays);
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	G_OBJECT_CLASS (boxes_display_parent_class)->finalize (obj);
#line 1029 "display.c"
}


GType
boxes_display_get_type (void)
{
	static volatile gsize boxes_display_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_display_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoxesDisplayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boxes_display_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoxesDisplay), 0, (GInstanceInitFunc) boxes_display_instance_init, NULL };
		static const GInterfaceInfo boxes_iproperties_provider_info = { (GInterfaceInitFunc) boxes_display_boxes_iproperties_provider_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType boxes_display_type_id;
		boxes_display_type_id = g_type_register_static (G_TYPE_OBJECT, "BoxesDisplay", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (boxes_display_type_id, BOXES_TYPE_IPROPERTIES_PROVIDER, &boxes_iproperties_provider_info);
		g_once_init_leave (&boxes_display_type_id__volatile, boxes_display_type_id);
	}
	return boxes_display_type_id__volatile;
}


static void
_vala_boxes_display_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	BoxesDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_DISPLAY, BoxesDisplay);
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	switch (property_id) {
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_CONFIG_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_value_set_object (value, boxes_display_get_config (self));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_CAN_GRAB_MOUSE_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_value_set_boolean (value, boxes_display_get_can_grab_mouse (self));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_MOUSE_GRABBED_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_value_set_boolean (value, boxes_display_get_mouse_grabbed (self));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_KEYBOARD_GRABBED_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_value_set_boolean (value, boxes_display_get_keyboard_grabbed (self));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_NEED_PASSWORD_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_value_set_boolean (value, boxes_display_get_need_password (self));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_NEED_USERNAME_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_value_set_boolean (value, boxes_display_get_need_username (self));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_PASSWORD_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_value_set_string (value, boxes_display_get_password (self));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_USERNAME_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		g_value_set_string (value, boxes_display_get_username (self));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 1107 "display.c"
		default:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 1113 "display.c"
	}
}


static void
_vala_boxes_display_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	BoxesDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_DISPLAY, BoxesDisplay);
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
	switch (property_id) {
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_CONFIG_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		boxes_display_set_config (self, g_value_get_object (value));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_CAN_GRAB_MOUSE_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		boxes_display_set_can_grab_mouse (self, g_value_get_boolean (value));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_MOUSE_GRABBED_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		boxes_display_set_mouse_grabbed (self, g_value_get_boolean (value));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_KEYBOARD_GRABBED_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		boxes_display_set_keyboard_grabbed (self, g_value_get_boolean (value));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_NEED_PASSWORD_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		boxes_display_set_need_password (self, g_value_get_boolean (value));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_NEED_USERNAME_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		boxes_display_set_need_username (self, g_value_get_boolean (value));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_PASSWORD_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		boxes_display_set_password (self, g_value_get_string (value));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		case BOXES_DISPLAY_USERNAME_PROPERTY:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		boxes_display_set_username (self, g_value_get_string (value));
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 1176 "display.c"
		default:
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 4 "/home/fborges/checkout/gnome-boxes/src/display.vala"
		break;
#line 1182 "display.c"
	}
}



